var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") return Reflect.decorate(decorators, target, key, desc);
    switch (arguments.length) {
        case 2: return decorators.reduceRight(function(o, d) { return (d && d(o)) || o; }, target);
        case 3: return decorators.reduceRight(function(o, d) { return (d && d(target, key)), void 0; }, void 0);
        case 4: return decorators.reduceRight(function(o, d) { return (d && d(target, key, o)) || o; }, desc);
    }
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("angular2/core");
var InfiniteScroller = (function () {
    function InfiniteScroller(element) {
        this.distance = 100;
        this.height = 'auto';
        this.hideScrollbar = false;
        this.next = new core_1.EventEmitter();
        this.prev = new core_1.EventEmitter();
        this.lastScroll = 0;
        this.isScrolling = false;
        this.container = element.nativeElement;
    }
    InfiniteScroller.prototype.ngAfterContentInit = function () {
        this.container.firstElementChild.scrollTop = 1;
    };
    InfiniteScroller.prototype.ngAfterViewInit = function () {
    };
    InfiniteScroller.prototype.doscroll = function (event) {
        this.isScrolling = true;
        var target = (typeof event.srcElement === 'undefined' ? event.target : event.srcElement);
        var targetRect = target.getBoundingClientRect();
        var bottomPosition = target.scrollHeight - (target.scrollTop + targetRect.height);
        var scrollDown = target.scrollTop > this.lastScroll;
        var saveLastScroll = this.lastScroll;
        this.lastScroll = target.scrollTop;
        if (scrollDown && target.scrollHeight - (target.scrollTop + targetRect.height) <= this.distance * 2) {
            this.next.emit(null);
            if (target.scrollHeight - target.scrollTop === target.clientHeight) {
                target.scrollTop -= 10;
            }
        }
        else if (!scrollDown && target.scrollTop <= this.distance * 2) {
            this.prev.emit(null);
            target.scrollTop = saveLastScroll > 0 ? saveLastScroll : 1;
        }
        this.isScrolling = false;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], InfiniteScroller.prototype, "distance");
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], InfiniteScroller.prototype, "height");
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], InfiniteScroller.prototype, "hideScrollbar");
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], InfiniteScroller.prototype, "next");
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], InfiniteScroller.prototype, "prev");
    InfiniteScroller = __decorate([
        core_1.Component({
            selector: "infinite-scroller"
        }),
        core_1.View({
            template: "\n\t\t<div class=\"scroll-container\" \n\t\t\t(scroll)=\"doscroll($event)\"\n\t\t\t[style.height.px]=\"height\"\n\t\t\t[class.hide-scrollbar]=\"hideScrollbar\">\n\t\t\t<ng-content></ng-content>\n\t\t</div>\n\t",
            styles: ["\n\t\t.scroll-container {\n\t\t\toverflow-y: scroll;\n\t\t\toverflow-x: hidden;\n\t\t}\n\t\t\n\t\t.scroll-container.hide-scrollbar::-webkit-scrollbar {\n\t\t\tdisplay: none;\n\t\t}\n\t\t\n\t\t.scroll-content {\n\t\t\toverflow: auto;\n\t\t}\n\t"],
            directives: []
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], InfiniteScroller);
    return InfiniteScroller;
})();
exports.InfiniteScroller = InfiniteScroller;

//# sourceMappingURL=InfiniteScroller.js.map
